/* $Id: design.java,v 1.60 2017/03/22 05:38:12 mit3 Exp $ */
/* design.java v1.5 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class design extends Applet 
    implements ActionListener, AdjustmentListener, 
	       MouseListener, MouseMotionListener, ItemListener, Runnable
{
    private Button btPP, btMM; // +,-
    private Button btWid, btNar; // >,<
    private Button btGT;     // view/text
    private Button[] btView; // graph|wire|cent|tune
    private Button btUG;     // up/gp
    private Button btSet;    // set data
    private Button btON;     // line/graph on.off
    private Button btSon;    // string on.off
    private Button btItype;  // curve/straight
    private Button btTune;
    private Label lBeat;
    private TextField tfA;   // key data
    private TextField tfL;   // length
    private TextField tfB;   // bante
    private TextField tfC;   // copper
    private Scrollbar sbWide;
    private Scrollbar sbBeat;
    private TextArea taA;
    private Choice chDT;
    private Canvas can;
    private Panel deck;
    private CardLayout Card;
    private Panel PN, PS, PW, PE;
    private Thread thr;

    final int KB = 88;
    final int Oct = 12;
    final int BHW = 28;       // bass ϥ޿
    final int MHW = 30;       // middle "
    final int HHW = 30;       // high   "
    final int A49 = Oct*4;    // Base
    final int C88 = KB-1;     // "
    final int BSTT = 0;       // "
    final int BEND = BHW-1;   // "
    final int WSTT = 1400;  // ̥μˡ
    final int SBS = 800;    // 
    final int SMD = 110;    // 
    final int AA = 440;

    final int GRAP = 0;
    final int WIRE = 1;
    final int CENT = 2;
    final int BEAT = 3;

    final int GTA = 0;        // ʲ Blist
    final int GAU = 1;
    final int COP = 2;
    final int ALD = 3;
    final int DEN = 4;
    final int TEN = 5;
    final int LOD = 6;
    final int ELO = 7;
    final int STR = 8;
    final double CBY = 1000; // logscaleΨ
    final double BHL = 14.5; // ϥޡ bass
    final double MHL = 13.5; // " middle
    final double HHL = 13;   // " high
    final double SPH = 32;   // Ŵʬ high
    final double SPL = 46;   // " low
    final String[] Views = {"Graph.","Wire","Cent"};
    final String[] Keynm =
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    private static final long serialVersionUID = 1L;

    Graphics gi;
    Image ig;
    Font Fnt, Fns;
    FontMetrics fm;
    DecimalFormat df1, df2;

    Interval I;
    Bante B;
    TuningKeyboard TK;
    TuningFormula2 TF2;
    ScaleCalculation SC;
    LeastSquares LS;
    Wire[] TG;
    minMax[] MX;

    boolean Msw; // mouse sw.
    boolean Csw; // calc. sw.
    boolean Gsw; // view/text sw.
    boolean Tsw; // up/gp type
    boolean Lsw; // line on/off
    boolean Ssw; // string on.off
    boolean Isw; // curve/straight
    boolean TUNEsw;
    int W;       // canvas width
    int H;       // canvas height
    int HH;      //  " H/2
    int FNT;     // եȥ
    int STT;     // drawϰ
    int END;     // "   λ
    int DOT;     // "  ɥå礭
    int DSF;     // "  ɥåȾʬ
    int NK;      // key
    int CX = 40; // cent max
    int List;    // data#
    int VIEW = GRAP;
    int WIDE;    // ̥ѹ
    double DX;   // wide
    double DS;   // KB
    double DY;   // log
    double DW;   // ˡإѹ
    double DC;   // HH/CX
    double XBS = 800;  // 
    double XMD = 110;  // 
    String Error;
    Color BG = new Color(00,180,255); // stress
    Color RB = new Color(120,0,180);  // freq.
    Color[] GC;

    public void init() {
	String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12; //
	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	Fns = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
	fm = getFontMetrics(Fnt);
	df1 = new DecimalFormat("#0.##");
	df2 = new DecimalFormat("#0.###");
	I = new Interval();
	B = new Bante();
	TF2 = new TuningFormula2();
	init_minmax();

	buildLayout();
	set_enabled();
	init_set();
	init_wire();
    }
    //
    public void buildLayout() {
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());

	PN = new Panel();
	PN.setLayout(new GridLayout(2,1,0,0));
        add(PN, "North");

	Panel n1 = new Panel();
	n1.setLayout(new FlowLayout());
        PN.add(n1);

	tfA = new TextField(54);
	tfA.setFont(Fns);
        tfA.setEditable(false);
        tfA.addActionListener(this);
        n1.add(tfA);

	Panel n2 = new Panel();
	n2.setLayout(new FlowLayout());
        PN.add(n2);

	btSet = new Button("Set");
        btSet.addActionListener(this);
        n2.add(btSet);

	n2.add(new Label("Length:", Label.RIGHT));

	tfL = new TextField(7);
	tfL.setFont(Fns);
        tfL.setEditable(true);
        tfL.addActionListener(this);
        n2.add(tfL);

	n2.add(new Label("Gauge:", Label.RIGHT));

	tfB = new TextField(4);
	tfB.setFont(Fns);
        tfB.setEditable(true);
        tfB.addActionListener(this);
        n2.add(tfB);

	n2.add(new Label("Copper:", Label.RIGHT));

	tfC = new TextField(5);
	tfC.setFont(Fns);
        tfC.setEditable(true);
        tfC.addActionListener(this);
        n2.add(tfC);

	n2.add(new Label("|"));

	chDT = new Choice();         // unit 
	for (int i = 0; i < MX.length; i++) {
	    chDT.addItem(MX[i].getName());
	}
	List = 8;                    // stress
	chDT.select(List);
        chDT.addItemListener(this);
        n2.add(chDT);
	//----------west

	PW = new Panel();
        PW.setLayout(new GridLayout(Views.length+3,1,0,0));
        add(PW, "West");

	btGT = new Button("View");
        btGT.addActionListener(this);
        PW.add(btGT);

	btView = new Button[Views.length];
	for (int i = 0; i < Views.length; i++) {
	    btView[i] = new Button(Views[i]);
            btView[i].addActionListener(this);
            PW.add(btView[i]);
        }

	btWid = new Button("< >");
        btWid.addActionListener(this);
        PW.add(btWid);

        btNar = new Button("> <");
        btNar.addActionListener(this);
        PW.add(btNar);
	//-----------east

	PE = new Panel();
	PE.setLayout(new GridLayout(6,1,0,0));
	add(PE, "East");

	btON = new Button("D.on");
        btON.addActionListener(this);
        PE.add(btON);

	btSon = new Button("S.on");
        btSon.addActionListener(this);
        PE.add(btSon);

	btUG = new Button("UP");
        btUG.addActionListener(this);
        PE.add(btUG);

	PE.add(new Label(""));

	btPP = new Button("+");
        btPP.addActionListener(this);
        PE.add(btPP);

	btMM = new Button("-");
        btMM.addActionListener(this);
        PE.add(btMM);
	//-----------south

	PS = new Panel();
	PS.setLayout(new GridLayout(2,1,0,0));
	add(PS, "South");

	sbWide = new Scrollbar(Scrollbar.HORIZONTAL,0, KB, 0, KB);
	sbWide.addAdjustmentListener(this);
	sbWide.setBlockIncrement(Oct);
	PS.add(sbWide);

	Panel s1 = new Panel();
	s1.setLayout(new GridLayout(1,4,0,0));
        PS.add(s1);

	btItype = new Button(" Curve ");
	btItype.addActionListener(this);
	s1.add(btItype);

	btTune = new Button("Tune ");
        btTune.addActionListener(this);
        s1.add(btTune);

	lBeat = new Label("Beat: 1.0", Label.RIGHT);
	s1.add(lBeat);

	sbBeat = new Scrollbar(Scrollbar.HORIZONTAL,10,1,0,31);
	sbBeat.addAdjustmentListener(this);
	sbBeat.setBlockIncrement(5);
	s1.add(sbBeat);
	//----------center

	deck = new Panel();
        Card = new CardLayout();
        deck.setLayout(Card);

	can = new MyCanvas();

	Panel Graph = new Panel();
        Graph.add(can);
        deck.add(Graph, "graph");

	taA = new TextArea("", 20, 45, TextArea.SCROLLBARS_BOTH);
        taA.setFont(Fns);
        taA.setEditable(false);

	ScrollPane Text = new ScrollPane();
        Text.add(taA);
        deck.add(Text, "text");

        add(deck, "Center");

	can.addMouseListener(this);
        can.addMouseMotionListener(this);
    }
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;
	HH = H/2;

	can.setSize(W, H); 
	ig = createImage(W, H);
	gi = ig.getGraphics();
	gi.setFont(Fnt);
    }
    public Dimension getCanvasD() {
	Dimension ds = PS.getSize();
	Dimension dn = PN.getSize();
	Dimension dw = PW.getSize();
	Dimension de = PE.getSize();
	Dimension da = getSize();
	int cw = da.width-(dw.width+de.width);
        int ch = da.height-(dn.height+ds.height)-8; //
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    //
    public void init_minmax() {
        MX = new minMax[9];

        MX[0] = new minMax(0, 200.0, "[kgf]", "(GTension)");
        MX[1] = new minMax(12.0, 30.0, "[#]", "Guage");
        MX[2] = new minMax(0, 4.0, "[mm]", "CopperDia.");
        MX[3] = new minMax(0, 10.0, "[mm]", "AllDia.");
        MX[4] = new minMax(0, 20.0, "[g/cm3]", "Density");
        MX[5] = new minMax(0, 2000.0, "[N]", "Tension");
        MX[6] = new minMax(0, 100.0, "[%]", "Load");
        MX[7] = new minMax(0, 20.0, "[mm]", "Elongation");
        MX[8] = new minMax(0, 300.0, "[kgf/mm2]", "Stress");
    }
    public class minMax {
        private double min;
        private double max;
        private String unit;
        private String name;

        public minMax() {
            setMinMax(0.0, 0.0, "", "");
        }
        public minMax(double m, double x, String u, String n) {
            setMinMax(m, x, u, n);
        }
        public void setMinMax(double m, double x, String u, String n) {
            min = m;
            max = x;
            unit = u;
            name = n;
        }
        public double getMin() {
            return min;
        }
        public double getMax() {
            return max;
        }
        public String getUnit() {
            return unit;
        }
        public String getName() {
            return name;
        }
    }
    //
    public void init_set() {
	STT = 0;       // log̥λϥޥΰ
	END = KB;      // " λ
	Error = "";

	WIDE = WSTT;
        XBS = SBS;
        XMD = SMD;
    }
    public void init_wire() {
	TK = new TuningKeyboard(KB);
	TG = new Wire[KB];
	for (int i = 0; i < KB; i++)
            TG[i] = new Wire(i);

	TG[C88].setWire(52, 12, 0);
	TG[A49].setWire(410, 15.5, 0);
	TG[BEND].setWire(1090, 17.0, 0.2);
	TG[BSTT].setWire(1020, 24.5, 2.6);

	SC = new ScaleCalculation(BSTT, BEND, A49, C88, TK, TG, TF2, Isw);
    }
    public boolean isBasekey(int key) {
	return (key == BSTT || key == BEND ||
		key == A49 || key == C88);
    }
    public void set_enabled() {
	boolean wsw = (VIEW == WIRE);
	boolean gsw = (VIEW == GRAP);
	boolean vgt = (wsw && !Gsw);
	btUG.setEnabled(vgt);  // up/gp
	btON.setEnabled(vgt);  // line on/off
	btSon.setEnabled(vgt); // string on/off

	boolean dt = (VIEW == CENT);
	chDT.setEnabled(!dt);  // wire value
	sbBeat.setEnabled(dt); // tune beat

	boolean vt = (!gsw && !Gsw);
	btPP.setEnabled(vt);  // +
	btMM.setEnabled(vt);  // -

	boolean vw = (wsw && Gsw);
	sbWide.setEnabled(!vw);

	chDT.setEnabled(vgt || (gsw && Gsw));

	boolean be = (!Isw);
	lBeat.setEnabled(be);
	sbBeat.setEnabled(be);
    }
    //
    public void mouseMoved(MouseEvent m) {
	if (!Msw) {
	    m_move(m);
	    can.repaint();
	}
    }
    public void m_move(MouseEvent e) {
	int mX = e.getX();
	switch (VIEW) {
	case GRAP:
	case CENT:
	    NK = (int)(mX/DX)+STT;
	    break;
	case WIRE:
	    NK = (int)(mX/DS);
	    break;
	default:
        }

	if (NK < 0)
	    NK = 0;
	if (NK >= KB)
	    NK = KB-1;
    }
    public void mousePressed(MouseEvent m) {
	Msw = !Msw;
    }
    public void mouseClicked(MouseEvent m) {}
    public void mouseDragged(MouseEvent m) {}
    public void mouseReleased(MouseEvent m) {}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited (MouseEvent m) {}
    public void itemStateChanged(ItemEvent e) {
	if (e.getSource() == chDT)
	    List = chDT.getSelectedIndex();

	disp_sw();
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == sbWide) {
	    switch (VIEW) {
	    case GRAP:
	    case CENT:
		STT = sbWide.getValue();
		break;
	    case WIRE:
		WIDE = sbWide.getValue();
		break;
	    default:
	    }
	}
	if (e.getSource() == sbBeat) {
	    disp_beat();
	}

	disp_sw();
    }
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == btPP)      // +
	    set_value(true);
	else if (e.getSource() == btMM) // -
	    set_value(false);

	else if (e.getSource() == btWid) // >
	    set_wide(true);
	else if (e.getSource() == btNar) // <
	    set_wide(false);

	else if (e.getSource() == btGT) // view/text
	    set_gt();
	
	else if (e.getSource() == btView[GRAP])
	    setGrap();
	else if (e.getSource() == btView[WIRE])
	    setWire();
	else if (e.getSource() == btView[CENT])
	    setCent();
	
	else if (e.getSource() == btTune)
	    setTune();

	else if (e.getSource() == btUG) // up/gp
	    set_ug();
       
	else if (e.getSource() == btSet) // set data
	    set_data();

	else if (e.getSource() == btON) // value on.off
	    set_on();
	else if (e.getSource() == btSon) // string on.off
	    set_string_onoff();

	else if (e.getSource() == btItype)
	    set_itype();

	set_enabled();
	disp_sw();
    }
    public void set_itype() {
	Isw = !Isw;
	btItype.setLabel(Isw ? "Straight" : " Curve ");

	SC.setIsw(Isw);
	if (VIEW == CENT)
	    start_run();

	Csw = false;
    }
    public void setGrap() {
        VIEW = GRAP;
        set_scrollbar(true);

	btWid.setLabel("< >");
	btNar.setLabel("> <");
	btPP.setLabel("+");
	btMM.setLabel("-");
    }
    public void setWire() {
        VIEW = WIRE;
        set_scrollbar(false);

	btWid.setLabel("B.>");
	btNar.setLabel("B.<");
	btPP.setLabel("W.>");
	btMM.setLabel("W.<");
    }
    public void setCent() {
	VIEW = CENT;
	set_scrollbar(true);
    }
    public void setTune() {
	TUNEsw = !TUNEsw;
	btTune.setLabel(TUNEsw ? "Clear" : "Tune ");

	if (TUNEsw)
	    start_run();
	else
	    clearCent();
    }
    public void clearCent() {
	for (int i = 0; i < KB; i++)
	    set_cent(i, 0);
    }
    public void set_curve() {
        double[] tmp = TF2.getCurve(get_beat_value());
        for (int i = 0; i < KB; i++)
	    set_cent(i, tmp[i]);
    }
    public void set_scrollbar(boolean sw) {
        if (sw) {
            sbWide.setValues(STT, END, 0, KB);
            sbWide.setUnitIncrement(1);
            sbWide.setBlockIncrement(Oct);
        } else {
            sbWide.setValues(WIDE, 100, WSTT/2, WSTT*5);
            sbWide.setUnitIncrement(WSTT/4);
            sbWide.setBlockIncrement(WSTT/2);
        }
    }
    public void set_gt() {
	Gsw = !Gsw;
	btGT.setLabel(Gsw ? "Text" : "View");
	Card.next(deck);
    }
    public void set_ug() {
	Tsw = !Tsw;
	btUG.setLabel(Tsw ? "GP" : "UP");
    }
    public void set_on() {
	Lsw = !Lsw;
	btON.setLabel(Lsw ? "D.off" : "D.on");
    }
    public void set_string_onoff() {
        Ssw = !Ssw;
        btSon.setLabel(Ssw ? "S.off" : "S.on");
    }
    public void set_data() {
	key_input(NK);
	Csw = !(isBasekey(NK) && !Csw);
	/* ϥ0,bend,a49,c88Ϸ׻ԥ */
    }
    public void set_value(boolean sw) {
	switch (VIEW) {
	case WIRE: // wid wire
	    XMD = sw ? XMD+20 : XMD-20;
	    break;
	case GRAP:
	    break;
	case CENT: // cent
	    int max = 100;
	    int min = 5;
	    CX = sw ? CX*2 : CX/2;
	    break;
	}
    }
    public void set_wide(boolean sw) {
	switch (VIEW) {
	case GRAP:
	case CENT: // 
	    END = sw ? END*2 : END/2;
            if (END > KB)
                END = KB;
            else if (END <= Oct)
                END = Oct+1;
            if (END+STT > KB)
                STT = KB-END;

            sbWide.setValues(STT, END, 0, KB);
	    break;
	case WIRE: // bass wire
	    XBS = sw ? XBS+20 : XBS-20;
	    break;
	default:
        }
    }
    public void key_input(int k) {
	String lng = tfL.getText();
	String gau = tfB.getText();
	String cop = tfC.getText();

	try {  // length
	    double lnum = Double.valueOf(lng).doubleValue();
            if (lnum < 0)
                tfL.setText("L ?");
            else {
		if (isBasekey(k))
		    TG[k].setLength(lnum);
		setLength(k, lnum);
		Csw = false;
	    }
        }
        catch(NumberFormatException e) {
            tfL.setText("in ?");
        }

	try {  // gauge
	    double gaug = Double.valueOf(gau).doubleValue();
	    if (gaug < 12 || gaug > 25)
		tfB.setText("over");
	    else {
		if (isBasekey(k))
                    TG[k].setGauge(gaug);
		setGauge(k, gaug);
		Csw = false;
	    }
	}
	catch(NumberFormatException e) {
            tfB.setText("in ?");
        }

	try {  // copper
	    double copp = Double.valueOf(cop).doubleValue();
	    copp = (copp <= 0) ? 0 : SC.get_Copper(copp);
	    if (isBasekey(k))
                TG[k].setCopper(copp);
	    setCopper(k, copp);
	    Csw = false;
	}
	catch(NumberFormatException e) {
            tfC.setText("in ?");
        }
    }
    public double calc_gtension() {
	double ten = 0, all = 0;
	int chord = 3;
	int sig = 10;

	for (int i = 0; i < KB; i++) {
	    ten = getGTension(i);
	    if (i >= sig && i < BHW) // 2ܸ
		all += ten;
	    all += isCopper(i) ? ten : ten*chord;
	}

	return all;
    }
    public double log_base(double value) {
	return Math.log(value)/Math.log(10);
    }
    public void disp_sw() {
        if (Gsw)
            re_write();     // text
        else 
            can.repaint();  // graph.
    }
    public void re_write() {
	switch (VIEW) {
	case GRAP:
	    write_data();
	    break;
	case WIRE:
	    write_wire();
	    break;
	case CENT:
	    write_cent();
	    break;
	default:
        }
    }    
    public void write_cent() {
	StringBuffer sb = new StringBuffer(1024);
	sb.append("Key#:  [Hz]:  [cent]\n");
	sb.append("--------------------\n");
	int ii;
	for (int i = 0; i < END; i++) {
	    ii = i+STT;
	    sb.append((ii+1)+"<");
	    sb.append(Keynm[ii%Oct]).append(">");
	    sb.append(d_dform2(get_ifreq(ii, 1)));
	    sb.append(d_dform(get_cent(ii))+"\n");
	}
	taA.setText(sb.toString());
    }
    public void write_wire() {
	StringBuffer sb = new StringBuffer(1024);
	int sig = 10;                     // 2ܸ sig~bhw
	sb.append(sig+",");
	sb.append(((BHW-sig)*2+sig)+",");
	sb.append((BHW+1)+"\n");
	for (int i = 0; i < KB; i++) {
	    if (i >= sig && i < BHW)
		sb.append(toString(i));
	    sb.append(toString(i));
	}

	taA.setText(sb.toString());
    }
    public void write_data() {
	StringBuffer sb = new StringBuffer(1024);
	sb.append("Key#: [Hz]: Length[mm]: Diameter[mm]: ");
	sb.append("Tension.G[Kgf]: Inharmon.[cent]: ");
	if (List > 0)
	    sb.append(MX[List].getName()).append(MX[List].getUnit());
	sb.append("\n");
	sb.append("----------------------------------------------------------\n");
	int ii;
	for (int i = 0; i < END; i++) {
	    ii = i+STT;
	    sb.append((ii+1)+"<");
	    sb.append(Keynm[ii%Oct]).append(">");
	    sb.append(d_dform2(get_ifreq(ii, 1)));
	    sb.append(d_dform(getLength(ii)));
	    sb.append(d_dform(getDiameter(ii)));
	    sb.append(d_dform(getGTension(ii)));
	    sb.append(d_dform2(getInha(ii)));
	    if (List > 0)
		sb.append(d_dform(get_data(ii, List)));
	    sb.append("\n");
	}

	taA.setText(sb.toString());
    }
    public String d_dform(double n){
	return ": "+df1.format((float)n);
    }
    public String d_dform2(double n){
	return ": "+df2.format((float)n);
    }
    public String dform(double n){
	return df1.format((float)n);
    }
    public String dform2(double n){
	return df2.format((float)n);
    }
    //---
    
    public void start_run() {
	if (Isw) { // straight
	    TK.startRun(get_beat_value());

	    thr = new Thread(this);
	    thr.start();
	} else { // curve
	    set_curve();
	    disp_sw();
	}
    }
    public void run() {
	tune_button_set(false);

	Error = "";
        int stime = 70;
	try {
	    while (TK.isRun()) {
		Thread.sleep(stime);
		disp_sw();
	    }
	} catch (InterruptedException e) {
            Error = "Run error."+e;
        }
        finally {
	    tune_button_set(true);
        }

	thr = null;
    }
    public void tune_button_set(boolean sw) {
	btTune.setEnabled(sw);
    }
    //
    public double get_ifreq(int kn, int pr) {
	return TK.getIfreq(kn, pr);
    }
    public double get_freq(int kn) {
	return TK.getFreq(kn);
    }
    public double getInha(int kn) {
	return TK.getInha(kn);
    }
    public double getInha(int kn, int pr) {
	return TK.getInha(kn, pr);
    }
    public void add_cent(int kn, double ce) {
	TK.addCent(kn, ce);
    }
    public void set_cent(int kn, double ce) {
	TK.setCent(kn, ce);
    }
    public double get_cent(int kn) {
	return TK.getCent(kn);
    }
    //
    public void setWire(int k, double le, double ba, double co) {
	TK.setWire(k, le, ba, co);
    }
    public void setLength(int k, double le) {
	TK.setLength(k, le);
    }
    public void setGauge(int k, double ga) {
	TK.setGauge(k, ga);
    }
    public void setCopper(int k, double co) {
	TK.setCopper(k, co);
    }
    public boolean isCopper(int k) {
	return TK.isCopper(k);
    }
    public double getLength(int k) {
	return TK.getLength(k);
    }
    public double getGauge(int k) {
	return TK.getGauge(k);
    }
    public double getCopper(int k) {
	return TK.getCopper(k);
    }
    public double getGTension(int k) {
	return TK.getGTension(k);
    }
    public double getDiameter(int k) {
	return TK.getDiameter(k);
    }
    public double getalld(int k) {
	return TK.getalld(k);
    }
    public String toString(int k) {
	return TK.toString(k);
    }
    //
    public double get_beat_value() {
	return sbBeat.getValue()/10.0;
    }
    //----------

    class MyCanvas extends Canvas {
	private static final long serialVersionUID = 1L;

	public void update(Graphics g) {
	    can.paint(g);
	}
	public void paint(Graphics g) {
	    paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }
    public void paintI() { 
	bg_black(gi);
	set_scale();
	set_dot();

	if (!Csw)
	    set_wire();

	switch (VIEW) {
	case GRAP:
	    dispWire(gi);
	    break;
	case WIRE:
	    if (!Ssw || Lsw)
		dispStrings(gi);
	    if (!Lsw) {
		dispData(gi, 0);
		if (List > 0)
		    dispData(gi, List);
	    }
	    break;
	case CENT:
	    dispCent(gi);
	    break;
	default:
	}

	write_tfa();
    }
    public void bg_black(Graphics g) {
	g.setColor(Color.black);
	g.fillRect(0, 0, W, H);
    }
    public void set_scale() {
	DX = W/(double)END;
	DS = W/(double)KB;
	DW = W/(double)WIDE;
	DC = HH/(double)CX;
    }
    public void set_dot() {
	int min = 1, max = 8;

	DOT = (int)DX;
	if (DOT > max)
	    DOT = max;
	if (DOT < min)
	    DOT = min;

	DSF = DOT/2;
    }
    public double get_data(int k, int lst) {
	switch(lst) {
	case GTA:
	    return getGTension(k);
	case GAU: 
	    return getGauge(k);
	case COP: 
	    return getCopper(k);
	case ALD:
	    return TK.getAlld(k);
	case DEN:
	    return TK.getDensity(k);
	case TEN: 
	    return TK.getTension(k);
	case LOD:
	    return TK.getLoad(k);
	case ELO:
	    return TK.getElongation(k);
	case STR:
	    return TK.getStress(k);
	default:
	    return 1;
	}
    }
    public void disp_cmemori(Graphics g) {
	disp_center_line(g);

	int dm = CX/5, mp, mm;
	String ps, ms;
	double dd;
	for (int i = 1; i <= 5; i++) {
	    dd = dm*DC*i;
	    mp = (int)(HH-dd);
	    mm = (int)(HH+dd);
	    g.setColor(Color.blue);
	    g.drawLine(0, mp, W, mp);
	    g.drawLine(0, mm, W, mm);

	    ps = ""+dm*i;
	    ms = "-"+dm*i;
	    g.setColor(Color.orange);
	    g.drawString(ps, 1, mp+FNT-3);
	    g.drawString(ms, 1, mm);
	}
    }
    public void disp_center_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, HH, W, HH);
    }
    public void disp_beat() {
	double be = get_beat_value();

	lBeat.setText("Beat: "+(float)be);
    }
    public void dispCent(Graphics g) {
	disp_cmemori(g);
	disp_keys(g);

	double x, hd = HH-DSF;
	int ii;
	for (int i = 0; i < END; i++) {
	    x = DX*i;
	    ii = i+STT;

	    g.setColor((ii == NK) ? get_dot_color(ii) : get_string_color(ii));
	    draw_dot(g, x, hd-get_cent(ii)*DC);
	}
    }
    public void dispData(Graphics g, int lst) {
	int max = (int)MX[lst].getMax();
	double dw = H/(double)max;
	int x1, y1;
	int dot = 4, ds = dot/2;

	for (int i = 0; i < KB; i++) {
	    y1 = (int)(H-get_data(i, lst)*dw-1);
	    x1 = (int)(DS*i);
	    g.setColor((i == NK) ? get_dot_color(i) : get_data_color(lst));
	    g.fillOval(x1-ds, y1-ds, dot, dot);
	}

	disp_memori(g, max, lst, dw);
	disp_ton(g);
    }
    public void disp_ton(Graphics g) {
	String st = dform(calc_gtension()/1000)+"[ton]";
	int ln = fm.stringWidth(st);
	
	g.setColor(Color.red);
	g.drawString(st, W-(ln+FNT), FNT);
    }
    public void disp_memori(Graphics g, int max, int lst, double dw) {
	int l = 5, stp;
	if (max > 1000)
	    stp = 100;
	else if (max >= 100)
	    stp = 10;
	else
	    stp = 1;

	int y;
	g.setColor(get_data_color(lst));
	for (int i = 0; i < max; i += stp) {
	    y = (int)(H-i*dw-1);
	    if (i%(stp*10) == 0)
		l = 15;
	    else if (i%(stp*5) == 0)
		l = 10;
	    else
		l = 7;
	    if (lst > 0)
		g.drawLine(W, y, W-l, y);
	    else
		g.drawLine(1, y, l, y);
	}
    }
    public Color get_data_color(int lst) {
	return (lst > 0) ? BG : Color.orange;
    }
    public double get_spx(int n) {
	double sft = 100;

	if (n < BHW)
	    return DW*(BHL*n+sft);
	else if (n < BHW+MHW)
	    return DW*(BHL*BHW+SPL+MHL*(n-BHW)+sft);
	else
	    return DW*(BHL*BHW+SPL+MHL*MHW+SPH+HHL*(n-BHW-MHW)+sft);
    }
    public int get_bass_length() {
	int max = 0;
	double l;
	for (int i = 0; i < BHW; i++) {
	    l = getLength(i);
	    if (max < l)
		max = (int)l;
	}
	return max+100;
    }
    public void dispStrings(Graphics g) {
	double botom, bass = get_bass_length()*DW;
	double ys = bass/8+30*DW;
	double xs = XMD*DW, xb = XBS*DW;
	double ml = (get_spx(BHW+MHW-1)-xs)/(double)(MHW-1);
	double bl = 20*DW;
	double x, dl;
	int h = can.getSize().height;

	ys = Tsw ? h-ys : ys;
	botom = Tsw ? h-bass : bass;
	for (int i = C88; i >= 0; i--) {
	    x = get_spx(i);
	    if (i < BHW)
		dl = xb+i*bl;
	    else if (i < BHW+MHW)
		dl = xs+(i-BHW)*ml;
	    else
		dl = x;

	    g.setColor((i == NK) ? get_dot_color(i) : get_string_color(i));

	    disp_ps_line(g, x, ys, dl, botom, i, DW);
	}

	g.setColor(Color.yellow); // s.point
	g.drawLine(1, (int)ys, W, (int)ys);
    }
    public Color get_dot_color(int k) {
	return isBasekey(k) ? Color.magenta : Color.green;
    }
    public Color get_string_color(int k) {
	return isCopper(k) ? Color.pink : Color.white;
    }
    public void disp_ps_line(Graphics g, double ax, double ay, 
			     double bx, double by, int i, double dh) {
	Point xy = fnp(ax, ay, bx, by, dh*getLength(i)*(1-1.0/SC.getSPoint(i)));
	g.drawLine((int)ax, (int)ay, xy.x, xy.y);

	Point yx = fnr(ax, ay, bx, by, dh*getLength(i)/SC.getSPoint(i));
	g.drawLine((int)ax, (int)ay, yx.x, yx.y);
    }
    public Point fnp(double ax, double ay, double bx, double by, double l) {
	double xsa = bx-ax;
	double ysa = by-ay;
	double xy2 = Math.sqrt(Math.pow(xsa,2)+Math.pow(ysa,2));
	Point p = new Point((int)(ax+xsa*l/xy2), (int)(ay+ysa*l/xy2));
	return p;
    }
    public Point fnr(double ax, double ay, double bx, double by, double l) {
	double xsa = ax-bx;
	double ysa = ay-by;
	double xy2 = Math.sqrt(Math.pow(xsa,2)+Math.pow(ysa,2));
	Point r = new Point((int)(ax+xsa*l/xy2), (int)(ay+ysa*l/xy2));
	return r;
    }
    public void set_wire() {
	SC.calcWire();
	Csw = true;
    }
    public void write_tfa() {
	StringBuffer sb = new StringBuffer(64);

	if (!Error.equals(""))
	    sb.append(Error);
	else {
	    sb.append((NK+1)+"<"+Keynm[NK%Oct]+">");
	    sb.append(dform2(get_ifreq(NK, 1))+"[Hz]");
	    switch(VIEW) {
	    case GRAP:
		sb.append("(1/"+dform(SC.getSPoint(NK))+"=");
		sb.append(dform(getLength(NK)/SC.getSPoint(NK))+"[mm])(");
		sb.append(dform2(SC.getIbase(NK))+")");
		sb.append(dform2(getInha(NK))+"[cent]");
		break;
	    case WIRE:
		sb.append(dform(get_data(NK, List))+MX[List].getUnit());
		break;
	    case CENT:
		sb.append(dform(get_cent(NK))+"[cent]");
		break;
	    default:
	    }

	    tfL.setText(dform(getLength(NK)));
	    tfB.setText(dform(getGauge(NK)));
	    tfC.setText(isCopper(NK) ? dform(getCopper(NK)) : "0");
	}

	tfA.setText(sb.toString());
    }
    public void draw_dot(Graphics g, double x, double y) {
	if (DOT > 2)
	    g.fillOval((int)x, (int)y, DOT, DOT);
	else
	    g.fillRect((int)x, (int)y, DOT, DOT);
    }
    public void dispWire(Graphics g) {
	disp_keys(g);
	disp_logscale(g); // DY

	double x;
	int ii, x1;
	for (int i = 0; i < END; i++) {
	    x = DX*i;
	    ii = i+STT;

	    g.setColor(RB);  // ȿ
	    draw_dot(g, x, hd_log(get_freq(ii)));

	    g.setColor(get_string_color(ii));  // Ĺ
	    draw_dot(g, x, hd_log(getLength(ii)));

	    g.setColor(Color.yellow);  // Ǹ
	    draw_dot(g, x, hd_log(getLength(ii)/SC.getSPoint(ii)));

	    g.setColor(Color.lightGray);  // 
	    draw_dot(g, x, hd_log(CBY*SC.getIbase(ii)));

	    g.setColor(Color.cyan);  // ϡ˥ƥ
	    draw_dot(g, x, hd_log(CBY*getInha(ii)));

	    if (ii == NK) {  // 
		x1 = (int)(x+DSF);
		g.setColor(get_cursol_color(ii));
		g.drawLine(x1, 0, x1, H);
	    }
	}

	disp_logunit(g);
	disp_lsm(g);
    }
    public double hd_log(double val) {
	return H-log_base(val)*DY-DSF;
    }
    public Color get_cursol_color(int k) {
	return isBasekey(k) ? Color.magenta : Color.white;
    }
    public void disp_logscale(Graphics g) {
	int miny = 1, maxy = 100000, y;
	DY = H/log_base(maxy);
	int cl;
	String cs;

	for (int i = miny; i <= maxy; i *= 10) {
	    y = (int)(H-log_base(i)*DY);

	    g.setColor(Color.blue);
	    g.drawLine(0, y, W, y);

	    g.setColor(Color.orange);  // left sclae
	    g.drawString(""+i, 1, y);

	    cs = dform2(i/CBY);
	    cl = fm.stringWidth(cs);
	    g.setColor(Color.green);   // right scale
	    g.drawString(cs, W-cl, y);
	}
    }
    public void disp_keys(Graphics g) {
	int x, ii;
	for (int i = 0; i < END; i++) {
	    x = (int)(DX*i+DSF);
	    ii = i+STT;

	    if (ii%Oct == 0) {
		g.setColor(Color.blue);
		g.drawLine(x, 0, x, H);

		g.setColor(Color.red);
		g.drawString((ii+1)+"A", x, H-FNT);
	    }
	}
    }
    public void disp_lsm(Graphics g) {
	String lsmb;
	int ln;

	if (Isw) { // straight
	    LS = SC.getLSM(TK.getG());
	    lsmb = "grade:"+dform2(LS.getLSMB());
	    ln = W-fm.stringWidth(lsmb);
	} else {
	    lsmb = TF2.toString();
	    ln = W-fm.stringWidth(lsmb);
	}

	g.setColor(Color.green);
	g.drawString(lsmb, ln/2, FNT*2);
    }
    public void disp_logunit(Graphics g) {
	int y0 = FNT, x0 = 1;

	String hs = "[Hz]";
	g.setColor(RB);
	g.drawString(hs, x0, y0);

	String sp = "[mm]";
	x0 += fm.stringWidth(hs);
	g.setColor(Color.yellow);
	g.drawString(sp, x0, y0);

	String s1 = "[m";
	x0 += fm.stringWidth(sp);
	g.setColor(Color.pink);
	g.drawString(s1, x0, y0);

	String s2 = "m]";
	x0 += fm.stringWidth(s1);
	g.setColor(Color.white);
	g.drawString(s2, x0, y0);

	String cs = "[cent]";
	int cl = fm.stringWidth(cs);
	g.setColor(Color.cyan);
	g.drawString(cs, W-cl, y0);

	g.setColor(Color.lightGray);
	g.drawString(cs, W-cl*2, y0);
    }
}
